/******************************************************************************
 *            Copyright (c) 2006 Michel Gutierrez. All Rights Reserved.
 ******************************************************************************/

function YTHQCheck(url,callback,args) {
	new HQChecker(url,callback,args);	
}

function YTHQChecker(url,callback,args) {
		this.url=url;
		this.callback=callback;
		this.args=args;
		this.done=false;
		this.ios = Components.classes["@mozilla.org/network/io-service;1"]
		                             .getService(Components.interfaces.nsIIOService);
		this.formats=[6];
		this.formatIndex=0;
}

YTHQChecker.prototype = {
	onStartRequest: function(request,context) {},
	onStopRequest: function(request,context) {
		if(this.done==false) {
			this.done=true;
			if(request.status==0) {
				try {
					this.callback(this.args,{ 
						baseUrl: this.url,
						url: this.url+"&fmt="+this.formats[this.formatIndex], 
						format: this.formats[this.formatIndex] 
					});
				} catch(e) {
					dump("!!! [YTHQChecker] check callback failed: "+e+"\n");
				}
			} else {
				this.formatIndex++;
				this.check();
			}
		}
	},
	check: function() {
		if(this.formatIndex<this.formats.length) {
			var uri=this.ios.newURI(this.url+"&fmt="+this.formats[this.formatIndex],null,null);
			this.checker=Components.classes['@mozilla.org/network/urichecker;1'].createInstance(Components.interfaces.nsIURIChecker);
			this.checker.init(uri);
			this.checker.loadFlags = Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
			this.checker.asyncCheck(this,this);
		} else {
			try {
				this.callback(this.args,{
					baseUrl: this.url
				});
			} catch(e) {
				dump("!!! [YTHQChecker] check callback failed: "+e+"\n");
			}
		}
	}
}
	
